<template>
  <div>
    <!--<template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="300"
        >
          <json-view :data="$data" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <div class="contSecc">
      <div>
        <div style="background:#fafafa">
          <div class="contModal cmodal">
            <div class="amodal tCenter">
              <div
                class="myDropProtocolos dropzone dz-clickable dz-verfolow"
                v-cloak
                @drop.stop.prevent="readFile"
                @dragover.prevent
              >
                <div class="dz-default dz-message" data-dz-message>
                  <div>
                    <img
                      v-if="!file.content_b64"
                      src="@/assets/img/cloud-computing.svg"
                      style="height:300px;width:450px"
                      alt
                    />
                    <img
                      v-else
                      src="@/assets/img/icoExcel.svg"
                      style="height:300px;width:450px"
                    />
                    <v-btn
                      @click="clearFile"
                      small
                      color="red"
                      fab
                      absolute
                      :class="[
                        {
                          desac: importingProtocolo
                        }
                      ]"
                      v-if="file.name_file"
                    >
                      <v-avatar size="25">
                        <v-img
                          :contain="true"
                          :aspect-ratio="1"
                          position="center"
                          src="@/assets/img/delete-white.svg"
                          class="white--text align-end"
                        ></v-img>
                      </v-avatar>
                    </v-btn>
                  </div>
                  <br />
                  <div>
                    <b class="name-file">{{ file.name_file }}</b>
                    <br />
                    <b>
                      Arrastra y suelta tu archivo excel aquí o
                      <label
                        :class="[{ desac: importingProtocolo }]"
                        class="file-select"
                      >
                        <a class="dz-clickable"
                          >Selecciónalo de tu computadora</a
                        >
                        <input
                          type="file"
                          accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
                          @change="readFile"
                        />
                      </label>
                    </b>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="btnCenter">
      <v-btn
        @click="dialogCancel = true"
        class="mr-6"
        depressed
        dark
        tile
        color="secundary"
        :class="[{ desac: importingProtocolo }]"
        >Regresar</v-btn
      >
      <v-btn
        depressed
        dark
        tile
        color="primary"
        @click="convertExcelToJSON()"
        :class="[
          { desac: importingProtocolo },
          { desac: $v.$invalid },
          { 'error-validation-btn': $v.$invalid }
        ]"
        >Importar datos</v-btn
      >
    </div>
    <!-- Dialogs-->
    <template>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¿Seguro que deseas
              <strong>cancelar</strong> la importación?
              <v-btn
                color="secondary"
                icon
                dark
                @click="dialogCancel = false"
                style="position: absolute;right: 0px;top: 0px;"
              >
                <v-icon>mdi-close</v-icon>
              </v-btn>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelImporting"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¡Se han
              <strong>guardado los cambios de manera exitosa!</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogSave = false"
                >Ok</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSize" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¡La imagen debe ser menor a
              <strong>1 MB!</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogSize = false"
                >No, cancelar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<style scoped>
.uploading-image {
  display: flex;
}
.file-select > input[type="file"] {
  display: none;
}
.name-file {
  font-style: italic;
}
</style>
<script>
import { required } from "vuelidate/lib/validators";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
export default {
  name: "Component-GestionProtocoloCargaExcel",
  data() {
    return {
      dialogErrorValidation: false,
      dialogCancel: false,
      dialogSave: false,
      dialogSize: false,
      importingProtocolo: false,
      file: {
        form_data: null,
        name_file: null,
        content_b64: null,
        content_type: null
      }
    };
  },
  props: ["data", "visualizarInfo"],
  validations: {
    file: {
      name_file: {
        required
      }
    }
  },
  methods: {
    initValues() {},
    clearFile() {
      this.file = {
        form_data: null,
        name_file: null,
        content_b64: null,
        content_type: null
      };
    },
    cancelImporting() {
      this.clearFile();
      this.data.importExcel = false;
    },
    readFile(e) {
      let file;
      if (e.type === "drop") {
        file = e.dataTransfer.files[0];
      } else {
        file = e.target.files[0];
      }
      if (!file) return;
      const size = file.size;
      if (size > 1024 * 1024) {
        this.dialogSize = true;
        return;
      }
      this.file.form_data = file;
      this.file.name_file = file.name;
      this.file.content_type = file.type;
      const reader = new FileReader();
      reader.readAsDataURL(file);
      reader.onload = e => {
        let result = e.target.result;
        this.file.content_b64 = result.split(",")[1];
      };
    },
    convertExcelToJSON() {
      const self = this;
      this.$v.$touch();
      if (!this.$v.$invalid) {
        let formData = new FormData();
        formData.append("uploadedFile", this.file.form_data);
        formData.append(
          "tipoCarga",
          this.data.protocolo.datos_generales.tipo_protocolo
        );
        self.importingProtocolo = true;
        axiosChecklist
          .post(
            "/consultaChecklistAdminService/postLeerExcell.json",
            formData,
            {
              headers: {
                "Content-Type": "multipart/form-data"
              }
            }
          )
          .then(response => {
            if (response) {
              self.data.importExcel = false;
              self.data.protocoloTemp = response.data;
              self.visualizarInfo(response.data);
              localStorage.setItem("dataTemp", JSON.stringify(response.data));
            }
          })
          .catch(error => {
            console.log(error);
            self.data.protocoloTemp = null;
          })
          .finally(function() {
            self.importingProtocolo = false;
          });
      } else {
        this.dialogErrorValidation = true;
      }
    }
  },
  created() {
    this.initValues();
  }
};
</script>
